| precision independent floating point operations for QuickForth

| precision independent fpu primitives - change fpu stack status!!!!!!!
| do not use if you don't know what are you doing!!
forth
: fstore fdecsp fstpedi ;
: fload fldedi fincsp ;

| fpu assembler mnemonics
: fldst ( n -- ) 8 << $c0d9 or 2, ; | fld st(n)
: fstpst ( n -- ) 8 << $d8dd or 2, ; | fstp st(n)
: fldz $eed9 2, ;
: fld1 $e8d9 2, ;
: fldpi $ebd9 2, ;
: fldlg2 $ecd9 2, ;
: fldln2 $edd9 2, ;
: fldl2e $ead9 2, ;
: fldl2t $e9d9 2, ;
: fabsst0 $e1d9 2, ;
: faddp $c1de 2, ;
: fsubst1 $e1d8 2, ; | fsub st0, st1
: fsubp $e9de 2, ;
: fsubrp $e1de 2, ;
: fmulp $c9de 2, ;
: fdivp $f9de 2, ;
: fdivrp $f1de 2, ;
: fsqrt $fad9 2, ;
: fsincos $fbd9 2, ;
: fptan $f2d9 2, ;
: fpatan $f3d9 2, ;
: fsin $fed9 2, ;
: fcos $ffd9 2, ;
: fyl2x $f1d9 2, ;
: f2xm1 $f0d9 2, ; |   windasme!!
: fchs $e0d9 2, ;
: fxch ( n -- ) 8 << $c8d9 or 2, ; | fxch st(n)
: fild $00db 2, ; | fild [eax]
: fistp $18db 2, ; | fistp [eax]
: frndint $fcd9 2, ;
: fxtract $f4d9 2, ;
: fscale $fdd9 2, ;
: fcmp $d9de 2, $9b 1, $f87fdd 3, m: dup $f8478b 3, $9e 1, $ad 1, ;
  | fcompp; fwait; fstsw [edi-8]; dup; mov eax, [edi-8]; sahf; lodsd
: fcmp2bool fcmp 1, here 0 1, cmp2bool fload ; |   

| floating point data manipulation

macro
: fnip fincsp ;
: f10@ fstore $28db 2, m: drop ; fast | fld tbyte [eax]; do not change!!
: f10! $38db 2, m: drop fload ; fast | fstp tbyte [eax]; do not change!!
: f8@  fstore $00dd 2, m: drop ; fast | fld qword [eax]; do not change!!
: f8!  $18dd 2, m: drop fload ; fast | fstp qword [eax]; do not change!!
: f4@  fstore $00d9 2, m: drop ; fast | fld dword [eax]; do not change!!
: f4!  $18d9 2, m: drop fload ; fast | fstp dword [eax]; do not change!!
: fdup 0 fldst fstore ; fast
: fdrop 0 fstpst fload ; fast
: fswap fldedi 1 fxch fstpedi ; fast
: fover fstore fldnext ; fast
: frot fload fload 2 fxch 1 fxch fstore fstore ; fast
: f-rot fload 1 fxch fload 1 fxch fstore fstore ; fast
: ftuck 0 fldst fldedi 1 fxch fstpedi fstore ; fast
: f2dup 0 fldst fldedi 1 fxch fstore fstore ; fast
: f2drop fincsp m: fdrop ; fast
: 0.0 fstore fldz ; fast
: 1.0 fstore fld1 ; fast
: inttofloat@ fstore fild m: drop ; fast
: inttofloat m: dup $f089 2, m: inttofloat@ m: drop ; fast | mov eax, esi
: round! fistp fload m: drop ; fast
: round m: dup $f089 2, m: cell- fistp fload m: @ ; fast | mov eax, esi

| floating point data structures

forth
: f10, here f10! 10 allot ;
: f8, here f8! 8 allot ;
: f4, here f4! 4 allot ;
macro
: f10literal fstore $0aeb 2, here f10, $2ddb 2, , ; | jmp [+10]; number; fld tbyte number;
: f8literal fstore $08eb 2, here f8, $05dd 2, , ; | jmp [+8]; number; fld qword number;
: f4literal fstore $04eb 2, here f4, $05d9 2, , ; | jmp [+4]; number; fld dword number;
: float+ precision literal, m: + ; fast
: float- precision literal, m: + ; fast
: floats precision literal, m: * ; fast
forth
: f10var 0.0 : f10var: create f10, ;
: f8var 0.0 : f8var: create f8, ;
: f4var 0.0 : f4var: create f4, ;
: f10const fdup wsparse 2dup
  entry as .macro m: f10literal c: f10literal x: ;;
  entry as .forth m: f10literal x: ;; ;
: f8const fdup wsparse 2dup
  entry as .macro m: f8literal c: f8literal x: ;;
  entry as .forth m: f8literal x: ;; ;
: f4const fdup wsparse 2dup
  entry as .macro m: f4literal c: f4literal x: ;;
  entry as .forth m: f4literal x: ;; ;

| floating point arithmetic functions

macro
: fnegate fchs ; fast
: fabs fabsst0 ; fast
: f+ fload faddp ; fast
: f- fload fsubrp ; fast
: f* fload fmulp ; fast
: f/ fload fdivrp ; fast

| comparisons

macro
: f<>  fload $74 fcmp2bool ; fast | je
: f=   fload $75 fcmp2bool ; fast | jne
: f>   fload $76 fcmp2bool ; fast | jbe
: f<   fload $73 fcmp2bool ; fast | jae
: f>=  fload $72 fcmp2bool ; fast | jb
: f<=  fload $77 fcmp2bool ; fast | ja
: f<>0 fldz  $74 fcmp2bool ; fast | je
: f=0  fldz  $75 fcmp2bool ; fast | jne
: f>0  fldz  $73 fcmp2bool ; fast | jae
: f<0  fldz  $76 fcmp2bool ; fast | jbe
: f>=0 fldz  $77 fcmp2bool ; fast | ja
: f<=0 fldz  $72 fcmp2bool ; fast | jb

forth
: strtofloat ( a n -- result | f ) fdup (strtofloat) dup not if fdrop then -rot 2drop ;
: floattostr ( -- a n ) (floattostr) fdrop ;
:: 2dup strtofloat if 2drop settrue else setfalse then ; is >float
: f. floattostr type space ;

: getmemforfloatingpointstack dup getmem + [ $c789 2, ] ; | mov edi, eax
