macro
: drop $068b 2, $04c683 3, ;

self
: ( ') parse drop drop ; ( no comments before this!! )
: | 10 parse drop drop ; | no comments before this!!

| QuickForth 2006 based on RetroForth 8.2.5
| (c) Golik D. N. 2005 - 2006
| Retroforth (c) retroforth.org

forth
: wsparse 32 parse ;
: lnparse 10 parse ;
: ' wsparse find ;
: m' wsparse mfind ;
: f' wsparse ffind ;

macro
: x:  ' compile ;
: ['] ' x: literal ;
: c: x: ['] ['] compile compile ; | supercompilation!!
: [m'] m' x: literal ;
: mc: x: [m'] ['] compile compile ; | supercompilation!!
: m: m' compile ; | this is needed for dwords.f!!
: f: f' compile ;

uses" dwords.f" | primitive data manipulation functions

| language processing words

forth
: here h0 @ ;
: getstackpointer dup [ $f089 2, ] ; | mov eax, esi
: setstackpointer [ $c689 2, ] ; | mov esi, eax

: class'  wsparse rot classfind ;
: reclass last @ 8 + ! ;
: reclass: class @ ' drop which @ 8 + ! ;

macro
: call $c289 2, m: drop $d2ff 2, ; | mov edx, eax; drop; call edx
: class: class' compile ;
: as ' x: literal c: reclass ;

: (if) $063b 2, $adad 2, 1, here 0 1, ; |   if | cmp eax, [esi]; lodsd; lodsd
: (0if) $c009 2, $ad 1, 1, here 0 1, ; |   0if or eax, eax; lodsd
: <>if $74 x: (if) ; | je
: =if  $75 x: (if) ; | jne
: >if  $7d x: (if) ; | jge
: <if  $7e x: (if) ; | jle
: >=if $7f x: (if) ; | jg
: <=if $7c x: (if) ; | jl
: ?if  $72 1, here 0 1, ; | jc
: if $74 m: (0if) ;  | je [then]
: 0if $75 m: (0if) ; | jne [then]
: then dup here swap - 1- swap c!  $90 1, here 1- h0 ! ; |    nop??    tail call!!
: else $eb 1, here 0 1, swap m: then ; | jmp byte [then]
: ;then x: ;; x: then ;

: repeat here ;
| : again here - 2 - $eb 1, 1, ; | jmp byte [repeat]
: again compile x: ;; ;
| : until m: if dup rot swap - 1- swap c! ( $90 1, here 1- h0 ! ) ;
: until m: 0if swap m: again m: then ;

: begin m: repeat ;
: while m: if ;
: end swap m: again m: then ;

| : for $c009 2, $74 1, here 0 1, $c189 2, m: drop | or eax, eax; je [next]; mov ecx, eax
|   m: repeat $51 1, ; | push ecx
| : next $59 1, here - 2 - $e2 1, 1, m: then ; | pop ecx; loop [for]
: for m: repeat $c009 2, $74 1, here 0 1, m: 1- m: >r ; | like if
: next m: r> swap m: again m: else m: drop m: then ;
| : for here m: >r ; | wrong!!
| : next m: r> m: 1- $8f0f 2, here - 4 - , m: drop ; | jg

forth
: later r> r> swap >r >r ;
: execute >r ;

: cmp2bool m: true m: else m: false m: then ;

: fast last @ dup 13 + dup 1- c@ entry as .forth 4 + @ execute x: ;; ;
 | makes forth word by executing last word, like : dup dup ;

macro
: =   m: =if  cmp2bool ; fast
: <>  m: <>if cmp2bool ; fast
: >   m: >if  cmp2bool ; fast
: <   m: <if  cmp2bool ; fast
: >=  m: >=if cmp2bool ; fast
: <=  m: <=if cmp2bool ; fast
: =0  m: 0if  cmp2bool ; fast
: <>0 m: if  cmp2bool ; fast
: >0  $7e m: (0if) cmp2bool ; fast | jle
: <0  $7d m: (0if) cmp2bool ; fast | jge
: >=0 $7c m: (0if) cmp2bool ; fast | jl
: <=0 $7f m: (0if) cmp2bool ; fast | jg

| self
| : ( repeat ') parse + c@ ') = dup 0if wsparse drop drop then until ; | multi-line comments!!

macro
: prior last @ >r last @ @ last ! wsparse find compile r> last ! ;
: vector $90909090 , $90 1, ;
: class> here 14 + x: literal c: reclass x: ;; ;

forth
: 0; dup 0if rdrop drop then ;

: create: wsparse entry ;
: literal, x: literal ;

macro
: vector: create: as .forth vector ;

forth
: create create: as .data ;
: var 0 : var: create , ;
: const create last @ cell+ ! ;
: define entry ; | like in c++!!
: define" '" parse define ;
: defined find ?if drop true else 2drop false then ;
: defined" '" parse defined ;

: +! dup @ rot + swap ! ;
: -! dup @ rot - swap ! ;
: allot h0 +! ;

: :: here ] ;
: alias create: last @ cell+ ! ;
 
: is here swap ' h0 ! compile x: ;; h0 ! ;
: vectorize ( as ad -- ) >r here swap r> h0 ! compile x: ;; h0 ! ;
| : devector $90909090 ' $90 over c! 1+ ! ;
: devector ( a -- ) $90909090 swap $90 over c! 1+ ! ;

forth
create list 8 cells allot
: loc: 1 list +! list @ cells list + last @ swap ! ;
: ;loc list @ cells list + @ last ! 1 list -! ;

uses" strings.f" | strings

| uses" float10.f" | floating point with 10-byte precision
 uses" float8.f" | floating point with 8-byte precision
| uses" float4.f" | floating point with 4-byte precision

uses" math.f"

| reset

." QuickForth build 02.2006 successfully loaded!!" cr cr

forth

uses" main.f"